/* mld.h */ 

#ifndef MLD_H
#define MLD_H

#include <string>
#include <sstream>
#include <vector>
#include <set>

struct finfo {
	std::string filename;
	std::string data;
};

struct linkOptions {

	linkOptions() :
		baseAddress(0x00400000),
		sectionAlign(4096),
		fileAlign(512),
		output(NULL),
		isWindowsSubsystem(false),
		compressRdata(false),
		warnOnDuplicateSymbol(true)
	{};

	// Optional configuration

	unsigned int baseAddress;
	unsigned int sectionAlign;
	unsigned int fileAlign;
	bool isWindowsSubsystem;
	bool compressRdata;
	bool warnOnDuplicateSymbol;
	std::set<std::string> dropSections;

	// Input

	std::string entry_func;
	std::vector<finfo> inputFiles;

	// Output

	FILE* output;
	std::ostringstream lastError;

	// Methods

	bool link();

};

#endif /* MLD_H */ 
