/* mld/file.cpp */

#include "file.h"
#include <cstdio>
#include <string>

finfo loadFile(const char* fname) {
	finfo ret = {0};

	ret.filename = fname;

	FILE* f = fopen(fname, "rb");
	if (f == NULL) {
		return ret;
	}

	fseek(f, 0, SEEK_END);
	unsigned long fsize = ftell(f);
	unsigned char* buff = new unsigned char[ fsize ];

	fseek(f, 0, SEEK_SET);
	if (fread(buff, 1, fsize, f) != fsize) {
		delete[] buff;
		return ret;
	}

	fclose(f);

	ret.flen = fsize;
	ret.data = buff;
	
	return ret;
}

void hexdump(const char* data, size_t len) {
	char buff[17] = {0};
	for(unsigned int i = 0; i != len; ++i) {

		if (i != 0 && (i % 16) == 0) {
			printf(" | %s\n", buff);
		}

		printf("%02X ", data[i]);

		buff[i % 16] = isalnum(data[i]) ? data[i] : '.';

	}
	if ((len % 16) != 0) {
		int j = 16 - (len % 16);
		while (j --> 0) {
			printf("   ");
		}
		printf(" | %.*s\n", len%16, buff);
	}
}

void hexdump(std::string& data) {
	return hexdump(data.c_str(), data.length());
}
