/* mld.h */ 

#ifndef MLD_H
#define MLD_H

#include <string>
#include <sstream>
#include <vector>
#include <set>

struct finfo {
	std::string filename;
	std::string data;
};

struct linkOptions {

	linkOptions() :
		baseAddress(0x00400000),
		sectionAlign(4096),
		fileAlign(512),
		output(NULL),
		isWindowsSubsystem(false),
		compressRdata(false)
	{};

	unsigned int baseAddress;
	unsigned int sectionAlign;
	unsigned int fileAlign;

	bool isWindowsSubsystem;
	bool compressRdata;

	FILE* output;

	std::string entry_func;
	std::vector<finfo> inputFiles;

	std::set<std::string> dropSections;

	std::ostringstream lastError;
};

bool mld_link(linkOptions& lo);

#endif /* MLD_H */ 
